//--------------------------------------------------------------------------
//
// This edit macro converts an AcuCobol error message file to MicroSoft error
// message format. After conversion the file can be used with primary command
// MERGEMSG.
//
// To use this macro:
//
// 1) Edit your AcuCobol program source file
// 2) Compile your AcuCobol program source file while still in edit
// 3) If errors result, recursively edit the error message file
//    (e.g. "e errors.out")
 
// 4) While in edit on the error message file execute edit macro "acutoms"
// 5) The macro converts your error message file in place, saves it, then
//    exits.
// 6) You are now back in your original program source file, invoke MERGEMSG
//    with the original message file name.
//
//--------------------------------------------------------------------------
void AcuToMS(void) {
 
  spfservice("cmd","l 1");      // position to first line
  spfservice("cmd",":r");       // replicate first line
  spfservice("cmd","l 1");      // re-position to first line
  spfservice("cmd","find ','"); // find end of file name
  spfservice("cmd","deleol");   // isolate file name
  //-----------------------------------------------------
  // convert ", line line-number: " to "(line-number,1) "
  //-----------------------------------------------------
  spfservice("cmd","c p', line #' p'xxxxxx(=' all");
  spfservice("cmd","c c'xxxxxx(' '(' all"); 
  spfservice("cmd","c p'#: ' p'=)=' all"); 
  spfservice("cmd","c c') ' c',1) ' all"); 
  spfservice("cmd","save;end"); 
   
} // acutoms
