//-----------------------------------------------------------------------------
// Macro: CENTER
//
// Form:  CENTER 
//
//   No parameters.
//
// Function:
//
//   This macro centers the non-blank portion of the current data line in
//   the center of current BOUNDS.
//
// NOTE: Most example macros provide trivial functionality. Their primary
// purpose is to show a variety of coding techniques.
//-----------------------------------------------------------------------------
void center(void) {
 
  char *line;
  char *pad;
  int   bounds_left, bounds_right, bounds_width;
  int   i;
   
  if (SPFservice("query","task_count")) {         // any tasks?
    bounds_left  = SPFservice("query","bounds_left");
    bounds_right = SPFservice("query","bounds_right");
    bounds_width = (bounds_right - bounds_left) + 1;
    line = SPFservice("query","line_data");
    if (line) {
      StrStripLeading(line," ");                  // strip leading blanks
      StrCenter(line," ",bounds_width);           // center within bounds
      i = bounds_left - 1;                        // cols left of left bound
      if (i) {
        pad = StrGenStr(" ",i);                   // generate the pad string
        StrInsSubstr(line,pad,1);                 // insert pad
      }
      SPFservice("set","line_data",line);         // set new line
      SPFservice("set","col_number",bounds_left); // put cursor at left bound
      }
    else {
      Msg("CENTER: line empty or non-data line");
    }
    }
  else {
    Msg("CENTER: not in edit");
  }
   
} // center
