//-----------------------------------------------------------------------
// This macro requires one parameter:  ...find-string...
//
// The "find-string" is specified in the same manner as that of Edit
// primary command FIND.
//
// THIS MACRO DELETES ALL LINES THAT DO NOT CONTAIN THE FIND STRING.
//
// After the operation is complete, the file is positioned to the top.
// An information message is issued indicating action taken by the macro.
//-----------------------------------------------------------------------
void delall(int argc, char *argv[]) {

  char *command;
  int   base_line_count;
  int   find_line_count;
  int   delete_count;

  if (argc == 2) {
    base_line_count = spfservice("query","line_count"); // retrieve total line count
    spfservice("cmd","x all");                 // exclude all lines
    command = strcompose("find all ",argv[1]); // synthesize FIND command with PARM1
    spfservice("cmd",command);                 // find lines containing target string
    find_line_count = spfservice("query","find_line_count"); // retrieve number of lines found
    spfservice("cmd","del all x");             // delete lines that do not contain the target string
    delete_count = base_line_count - find_line_count;  // calc number of lines deleted
    spfservice("cmd","reset");                 // make all lines visible
    spfservice("cmd","top");                   // position file to top
    spfservice("cmd","cursor");                // leave cursor in primary command field
    // issue info message
    Msg(strcompose("DELBUT deleted ",delete_count," lines that did not contain string:  ",argv[1]));
    }
  else {
    Msg("DELBUT macro requires one parameter:  ...find-string...");
  }

} // delall
