//-----------------------------------------------------------------
// This macro demonstrates DLL entrypoint registration and calling.
// (see HELP topic "Calling External Programs")
//-----------------------------------------------------------------
void dlldemo(void) {

  char *response;
  char *msg;
  char *p[];       // array of parameters
  char *path_to_dll;
  int   hDllEp[];  // array of DLL entrypoint handles

  //----------------------------------------------------
  // *** Set "path_to_dll" var to point to YOUR dll ***
  //----------------------------------------------------
  // NOTE: In var value use "\\" for "\"
  //----------------------------------------------------
  path_to_dll = SpfService("query","SPF_INSTALL_DIR");
  strcat(path_to_dll,"\\Bin\\test.dll");

  //----------------
  // load parm array
  //----------------
  StrParse(p,"one two three four five six seven eight"," ");

  // load DLL entrypoint array
  hDllEp[0]  = DllEpRegister(path_to_dll,"test0", FALSE,0);
  hDllEp[1]  = DllEpRegister(path_to_dll,"test1", FALSE,1);
  hDllEp[2]  = DllEpRegister(path_to_dll,"test2", FALSE,2);
  hDllEp[3]  = DllEpRegister(path_to_dll,"test3", FALSE,3);
  hDllEp[4]  = DllEpRegister(path_to_dll,"test4", FALSE,4);
  hDllEp[5]  = DllEpRegister(path_to_dll,"test5", FALSE,5);
  hDllEp[6]  = DllEpRegister(path_to_dll,"test6", FALSE,6);
  hDllEp[7]  = DllEpRegister(path_to_dll,"test7", FALSE,7);
  hDllEp[8]  = DllEpRegister(path_to_dll,"test8", FALSE,8);

  hDllEp[9]  = DllEpRegister(path_to_dll,"test9", TRUE,0);
  hDllEp[10] = DllEpRegister(path_to_dll,"test10",TRUE,1);
  hDllEp[11] = DllEpRegister(path_to_dll,"test11",TRUE,2);
  hDllEp[12] = DllEpRegister(path_to_dll,"test12",TRUE,3);
  hDllEp[13] = DllEpRegister(path_to_dll,"test13",TRUE,4);
  hDllEp[14] = DllEpRegister(path_to_dll,"test14",TRUE,5);
  hDllEp[15] = DllEpRegister(path_to_dll,"test15",TRUE,6);
  hDllEp[16] = DllEpRegister(path_to_dll,"test16",TRUE,7);
  hDllEp[17] = DllEpRegister(path_to_dll,"test17",TRUE,8);

  // call functions returning void (no return)
  DllEpCall(hDllEp[0]);
  DllEpCall(hDllEp[1],p[0]);
  DllEpCall(hDllEp[2],p[0],p[1]);
  DllEpCall(hDllEp[3],p[0],p[1],p[2]);
  DllEpCall(hDllEp[4],p[0],p[1],p[2],p[3]);
  DllEpCall(hDllEp[5],p[0],p[1],p[2],p[3],p[4]);
  DllEpCall(hDllEp[6],p[0],p[1],p[2],p[3],p[4],p[5]);
  DllEpCall(hDllEp[7],p[0],p[1],p[2],p[3],p[4],p[5],p[6]);
  DllEpCall(hDllEp[8],p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7]);

  // call functions returning "char *"
  response = DllEpCall(hDllEp[9]);
  Msg(response);
  response = DllEpCall(hDllEp[10],p[0]);
  Msg(response);
  response = DllEpCall(hDllEp[11],p[0],p[1]);
  Msg(response);
  response = DllEpCall(hDllEp[12],p[0],p[1],p[2]);
  Msg(response);
  response = DllEpCall(hDllEp[13],p[0],p[1],p[2],p[3]);
  Msg(response);
  response = DllEpCall(hDllEp[14],p[0],p[1],p[2],p[3],p[4]);
  Msg(response);
  response = DllEpCall(hDllEp[15],p[0],p[1],p[2],p[3],p[4],p[5]);
  Msg(response);
  response = DllEpCall(hDllEp[16],p[0],p[1],p[2],p[3],p[4],p[5],p[6]);
  Msg(response);
  response = DllEpCall(hDllEp[17],p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
  Msg(response);

}
