//---------------------------------------------------------------------------
// This macro is invoked in place of "END" to create the effect of ending the
// edit session then re-invoking SPF/SE in a File List that matches the
// current edit file's path and type. For example, if you are editing file:
//
//     C:\temp\test1.txt
//
// When you terminate edit via "endwithlist" you will a get File List for:
//
//     C:\temp\*.txt
//
//---------------------------------------------------------------------------
void EndWithList(void) {

  char *path_exe;
  char *path_edit;
  char *pcmd;
  char *file_type;
  char *mode;

  path_exe  = SPFService("vget","ZSPFEXE");
  path_edit = SPFService("vget","ZDSNPATH");
  file_type = SPFService("vget","ZDSNTYPE");
  if (strlen(path_edit) > 0) {
    mode = SPFService("vget","ZEDITVIACMDLINE");
    if (mode == "TRUE") {
      if (strlen(file_type) > 0) {
        pcmd = StrCompose('system nointerp ','"',path_exe,'" /H "',path_edit,'\\',file_type,'"');
        }
      else {
        pcmd = StrCompose('system nointerp ','"',path_exe,'" /H "',path_edit,'"');
      }
      SPFService("cmd",pcmd); // launch new SPF in File List with same path and type as edit file
    }
    SPFService("cmd","end"); // end current edit
    }
  else {
    Msg("You must be in edit to use ENDWITHLIST macro.");
  }

} //EndWithList
