//-----------------------------------------------------------------------------
// This macro is used in conjunction with the DOS DIR command. The following 
// procedure yields a clean list of file names from the captured output of
// DIR:
//
// 1) Do a DOS DIR for the desired directory and file type redirecting the
//    output to a temporary file. Example,
//
//       DIR C:\SOURCE\EDIT\*.C > C:\TEMP\EDIT_C.TXT
//
// 2) Use SPF/SE to edit the temporary list file. In edit, invoke edit macro
//
//       LISTFIXUP
//
//    This macro modifies the current edit file to produce a clean list of file
//    names. This clean file list can then be used as input to utility programs
//    that operate from a list of file names (e.g. CTAGS).
//
//-----------------------------------------------------------------------------
void listfixup(void) {
 
  char *command;
  int   total_lines;
   
  total_lines = spfservice("query","LINE_COUNT");
  command = strcompose("L ",total_lines); // synthesize locate command
   
  spfservice("cmd","L 1");
  spfservice("cmd",":D5");
  spfservice("cmd",command); // locate to bottom file line
  spfservice("cmd","UP 2");
  spfservice("cmd",":D2");
  spfservice("cmd","L 1");
  spfservice("cmd",":((44");
  spfservice("cmd",command);
  spfservice("cmd","UP 1");
  spfservice("cmd",":((");
  spfservice("cmd","TOP");
  spfservice("cmd","SORT");
   
}
