//--------------------------------------------------------------
// The first function in any SPF/SE macro source file is
// considered the "main" function. This macro demonstrates the
// standard method of declaring and accessing parameters in the
// "main" function of your macros. 
//
// Parameter 1 of the function declaration is ARGC, the count of 
// parameters passed. The "C" standard parameter list automatically
// includes the "program name" (fully qualified path name)
// as the first parameter.
//
// Parameter 2 of the function declaration is ARGV, an array of
// character strings representing the passed parameters parsed
// on blank (1 through ARGC). The first parameter is always the   
// "program name" as described above.
//--------------------------------------------------------------
void anyname(int argc, char *argv[]) {

  char *msg;
  int   i;

  i = 0;
  while (i < argc) {
    // print parameter number and value
    msg = StrCompose("Parameter(",(i+1),") = ",argv[i]);
    Msg(msg);
    ++i;
  } // while

} // anyname
