//-----------------------------------------------------------------------------
//
// This sample edit macro parses an HTM or HTML source file from left to right,
// top to bottom. It separates the HTML tags and text putting the tags on
// individual lines. the resulting parsed file is saved under new name
// "parsed.htm" in the same directory as the current edit file.
//
// The macro is not perfect. It assumes that text between markup does not
// contain start of tag character "<". If it does, the parser will not produce
// correct results.
//
//-----------------------------------------------------------------------------
void ParseHTM(void) {

  char *pcmd;
  char *lcmd;
  char *file_extension;
  char *result_filename;
  int   line_length;
  int   find_count;
  int   cur_linenum;
  int   located_linenum;
  int   col_start_of_tag;
  int   col_end_of_tag;
  int   tag_count = 0;
  int   i;
  BOOL  done = FALSE;
  BOOL  look_for_start = TRUE;

  cur_linenum = 1;
  while (!done) {
    pcmd = strcompose("locate ",cur_linenum); // synthesize LOCATE command
    spfservice("cmd",pcmd);                   // position to line
    located_linenum = spfservice("query","line_number"); // get line nu8mber of located line
    if (located_linenum == cur_linenum) {
      //-------------------
      // parse current line
      //-------------------
      spfservice("cmd",":.A");                       // label this line ".A"
      if (look_for_start) {
        spfservice("cmd","find c'<' .a .a");         // find next "<" on this line
        find_count = spfservice("query","find_string_count");
        if (find_count == 1) {
          //-------------------
          // found start of tag
          //-------------------
          look_for_start = FALSE;                    // reset
          col_start_of_tag = spfservice("query","col_number");
          if (col_start_of_tag > 1) {
            //---------------------
            // some text before tag
            //---------------------
            lcmd = strcompose(":ts",col_start_of_tag);
            spfservice("cmd",lcmd);                  // split line at start of tag
            cur_linenum = spfservice("query","line_number"); // continue parse on new line
          }
          // The next pass through the loop we are looking for the matching ">"
          }
        else {
          // start of tag not found on current line, continue parse on next line
          ++cur_linenum;
        }
        }
      else {
        spfservice("cmd","find c'>' .a .a");         // find ">" on this line
        find_count = spfservice("query","find_string_count");
        if (find_count == 1) {
          //-----------------
          // found end of tag
          //-----------------
          ++tag_count;                               // incr tag found count
          look_for_start = TRUE;                     // set up to look for next tag
          line_length = spfservice("query","line_length"); // get line data length
          col_end_of_tag = spfservice("query","col_number");
          if (col_end_of_tag < line_length) {
            //--------------------
            // some text after tag
            //--------------------
            i = col_end_of_tag + 1;                  // split colume
            lcmd = strcompose(":ts",i);
            spfservice("cmd",lcmd);                  // split line at end of tag
            cur_linenum = spfservice("query","line_number"); // continue parse on new line
            }
          else {
            // end of tag is at end of line, continue parse on next line
            ++cur_linenum;
          }
          }
        else {
          // end of tag not found on current line, continue parse on next line
          ++cur_linenum;
        }
      }
      }
    else {
      done = TRUE; // no more lines
    }
  } // while
  if (tag_count > 0) {
    file_extension = spfservice("vget","ZDSNEXT");   // get current file's type
    if (file_extension == "") {                      // no file extension?
      file_extension = "txt";                        // set default extension "txt"
    }
    result_filename = strcompose("parsed.",file_extension);  // synthesize result file name
    pcmd = strcompose("export ",result_filename);    // synthesize EXPORT command
    spfservice("cmd","select all");                  // select all lines in file
    spfservice("cmd",pcmd);                          // write modified result file in same dir
    spfservice("cmd","cancel");                      // end edit with no save
    msg(strcompose("Parsed result is in file:\n\n",result_filename));
    }
  else {
    spfservice("cmd","top");                         // stay in edit at top of file
    msg("Not tags found.");
  }

} // ParseHTM
