//---------------------------------------------------------------------------
// THIS IS NOT A MACRO (see HELP topic "Calling External Programs") 
//
// This program source provides a stub function for all the permutations of
// external DLL calls that can be made using "DllEpRegister" and "DllEpCall"
// The names can be changed as required.
// 
// Macro DLLDEMO.C demonstrates entrypoint registration and calls these
// functions.
//
// The compiled form of this source is in TEST.DLL
//
// These functions could serve as "wrappers" for calling other DLL based
// entrypoints which have specific parameter requirements that can not be 
// supported directly in this interface (e.g. passing or returning types
// other than "char *")
//
//---------------------------------------------------------------------------

//---------------------------
// Functions returning "void"
//---------------------------
 
#include <windows.h>
#include <stdio.h>
 
static char g_buf[128];
 
__declspec(dllexport)
void test0(void) {
 
  strcpy(g_buf,"TEST0: no parms in, no return");
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test1(char *p1) {
 
  sprintf(g_buf,
    "TEST1: p1=%s, no return",
    p1);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test2(char *p1, char *p2) {
 
  sprintf(g_buf,
    "TEST2: p1=%s p2=%s, no return",
    p1,p2);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test3(char *p1, char *p2, char *p3) {
 
  sprintf(g_buf,
    "TEST3: p1=%s p2=%s p3=%s, no return",
    p1,p2,p3);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test4(char *p1, char *p2, char *p3, char *p4) {
 
  sprintf(g_buf,
    "TEST4: p1=%s p2=%s p3=%s p4=%s, no return",
    p1,p2,p3,p4);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test5(char *p1, char *p2, char *p3, char *p4,
           char *p5) {
 
  sprintf(g_buf,
    "TEST5: p1=%s p2=%s p3=%s p4=%s p5=%s, no return",
    p1,p2,p3,p4,p5);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test6(char *p1, char *p2, char *p3, char *p4,
           char *p5, char *p6) {
 
  sprintf(g_buf,
    "TEST6: p1=%s p2=%s p3=%s p4=%s p5=%s p6=%s, no return",
    p1,p2,p3,p4,p5,p6);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test7(char *p1, char *p2, char *p3, char *p4,
           char *p5, char *p6, char *p7) {
 
  sprintf(g_buf,
    "TEST7: p1=%s p2=%s p3=%s p4=%s p5=%s p6=%s p7=%s, no return",
    p1,p2,p3,p4,p5,p6,p7);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
__declspec(dllexport)
void test8(char *p1, char *p2, char *p3, char *p4,
           char *p5, char *p6, char *p7, char *p8) {
 
  sprintf(g_buf,
    "TEST8: p1=%s p2=%s p3=%s p4=%s p5=%s p6=%s p7=%s p8=%s, no return",
    p1,p2,p3,p4,p5,p6,p7,p8);
  MessageBox(NULL,g_buf,NULL,MB_OK);
   
}
 
//-----------------------------
// Functions returning "char *"
//-----------------------------
 
__declspec(dllexport)
char *test9(void) {
 
  strcpy(g_buf,"TEST9: no parms in");
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test10(char *p1) {
 
  sprintf(g_buf,
    "TEST10: p1=%s",
    p1);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test11(char *p1, char *p2) {
 
  sprintf(g_buf,
    "TEST11: p1=%s p2=%s",
    p1,p2);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test12(char *p1, char *p2, char *p3) {
 
  sprintf(g_buf,
    "TEST12: p1=%s p2=%s p3=%s",
    p1,p2,p3);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test13(char *p1, char *p2, char *p3, char *p4) {
 
  sprintf(g_buf,
    "TEST13: p1=%s p2=%s p3=%s p4=%s",
    p1,p2,p3,p4);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test14(char *p1, char *p2, char *p3, char *p4,
           char *p5) {
 
  sprintf(g_buf,
    "TEST14: p1=%s p2=%s p3=%s p4=%s p5=%s",
    p1,p2,p3,p4,p5);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test15(char *p1, char *p2, char *p3, char *p4,
           char *p5, char *p6) {
 
  sprintf(g_buf,
    "TEST15: p1=%s p2=%s p3=%s p4=%s p5=%s p6=%s",
    p1,p2,p3,p4,p5,p6);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test16(char *p1, char *p2, char *p3, char *p4,
           char *p5, char *p6, char *p7) {
 
  sprintf(g_buf,
    "TEST16: p1=%s p2=%s p3=%s p4=%s p5=%s p6=%s p7=%s",
    p1,p2,p3,p4,p5,p6,p7);
  return(g_buf);
   
}
 
__declspec(dllexport)
char *test17(char *p1, char *p2, char *p3, char *p4,
           char *p5, char *p6, char *p7, char *p8) {
 
  sprintf(g_buf,
    "TEST17: p1=%s p2=%s p3=%s p4=%s p5=%s p6=%s p7=%s p8=%s",
    p1,p2,p3,p4,p5,p6,p7,p8);
  return(g_buf);
   
}
