//-----------------------------------------------------------------------
// This Edit macro excludes from the current line to the end of the file.
// We use XX instead of X99999 to handle the case of files with more the
// 100,000 or more lines.
//-----------------------------------------------------------------------
void x0(void) {

  char *pcmd;
  char *context;
  int   row;
  int   top_linenum;

  context = spfservice("query","context");    // get current cursor row
  row = spfservice("query","cursor_row");     // get current cursor row
  if (row > 0) {
    if (row == 1) {
      spfservice("cmd","up 1");               // make at least 1 line visible after exclude
      row = 2;                                // put cursor on original line
      spfservice("set","cursor_row",row);     // put cursor on XX marker line
    }
    top_linenum = spfservice("query","line_number_top"); // get line number for top line
    spfservice("cmd",":xx");                  // put XX line command on current line
    spfservice("cmd","locate .zlast");        // position to last line in file
    spfservice("cmd","up 1");                 // move up 1 to last data line
    spfservice("cmd",":xx");                  // put XX line command on last data line
    spfservice("cmd","enter");                // exclude from current line to BOF
    pcmd = strcompose("locate ",top_linenum); // synthesize LOCATE primary command
    spfservice("cmd",pcmd);                   // re-position to original top display line
    spfservice("set","cursor_row",row);       // put cursor on XX marker line
    spfservice("set","col_number",1);         // put cursor on XX marker line
    if (context == "EDIT") {
       spfservice("cmd","cursormove left 7"); // move to col 1 of line command field
    }
    }
  else {
    msg("Put cursor on data line before using X0 macro.");
  }

} // x0
